''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:        '
'                       '
'                                                        '
' Inputs:            '
'                                                        '
' Returns:                                         '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'    
Const EventInfo    = 0
Const EventError   = 1

'    
Const SW_HIDE            = 0
Const SW_NORMAL          = 1
Const SW_SHOWMINIMIZED   = 2
Const SW_SHOWMAXIMIZED   = 3
Const SW_SHOWNOACTIVATE  = 4
Const SW_SHOW            = 5
Const SW_MINIMIZE        = 6
Const SW_SHOWMINNOACTIVE = 7
Const SW_SHOWNA          = 8
Const SW_RESTORE         = 9
Const SW_SHOWDEFAULT     = 10
Const SW_FORCEMINIMIZE   = 11

'  
Dim strComputer
Dim strNamespace
Dim ComputerName
Dim Login
Dim Password
Dim ProcessName
Dim Window
Dim Priority
Dim Source
Dim objLocator
Dim FSO
Set FSO = CreateObject("Scripting.FileSystemObject")

'   
Dim objArgs
Set objArgs = WScript.Arguments

If objArgs.Count >= 6 Then
  Do
   '       WMI
   strComputer = objArgs(0)

   '   
   Login = objArgs(1)

   '  
   Password = objArgs(2)

   '    
   strNamespace = "Root\CIMV2"

   '   
   ProcessName = objArgs(3)

   '     
   Source      = objArgs(4)

   '    
   Priority    = fPriority(objArgs(5))

   '   7-  -      
   If objArgs.Count > 6 Then
    Window = fWindow(objArgs(6))
   Else
    Window = SW_NORMAL
   End If

   '   
   ComputerName = NameOfComp()
   
   '     -         
   If Not FileStatus(Source) Then
      call LogMsg(EventError, "Source not exist: " & Source & " on " & ComputerName)
      Exit Do
   End If

   '     - 
   If Not StatusProcess(ProcessName) Then Call CreateProcess(Source, Priority, Window)

   '      
   Dim objWMIService
   If strComputer = "." Then
     Set objWMIService = GetObject("winmgmts:\\" & strComputer &  "\" & strNamespace) 
   Else
     Set objLocator = CreateObject("WbemScripting.SWbemLocator")
     Set objWMIService = objLocator.ConnectServer(strComputer, strNamespace, Login, Password)
   End If

   '       
   Dim MySink
   Set MySink = WScript.CreateObject("WbemScripting.SWbemSink","SINK_")

   '      
   objWMIservice.ExecNotificationQueryAsync MySink, _
   "SELECT * FROM __InstanceDeletionEvent WITHIN 10 WHERE TargetInstance ISA 'Win32_Process' and TargetInstance.Name='" & ProcessName & "'"

   call LogMsg(EventInfo, "Monitoring the process: " & ProcessName & " started on " & ComputerName)
 
   '   
   While (True)
      Wscript.Sleep(1000)
   Wend
  Loop
Else
  '      
  Call LogMsg(EventError, "Arguments failure" & " on " & ComputerName)
End If
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                 '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                     '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:   OnObjectReady            '
'          OnCompleted  SWbemSink                 '
'                                                        '
' Inputs:  WMI                                    '
'                                                        '
' Returns:                                         '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub SINK_OnObjectReady(objObject, objAsyncContext)
  Call LogMsg(EventInfo, "__InstanceDeletionEvent event has occurred. Process: " & ProcessName & " on " & ComputerName)
  Call CreateProcess(Source, Priority, Window)
End Sub

Sub SINK_OnCompleted(objObject, objAsyncContext)
  Call LogMsg(EventInfo, "Event call complete.")
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:                            '
'                                                        '
' Inputs:    ,        '
'                                                        '
' Returns:                                         '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub CreateProcess(strSource, strPriority, intWindow)

  '     WMI
  Dim objService
  If strComputer = "." Then
    Set objService = GetObject("WinMgmts:\\" & strComputer & "\" & strNamespace)

    '     Win32_ProcessStartup
    Dim objStartup
    Set objStartup = objService.Get("Win32_ProcessStartup")
    Dim objConfig
    Set objConfig = objStartup.SpawnInstance_

    '     
    objConfig.ShowWindow = intWindow

    '  
    objConfig.PriorityClass = strPriority

    '   
    Dim intProcessID

    '  
    Dim intError

    '     WMI 
    '    Create
    Dim objProcess
    Set objProcess = GetObject("WinMgmts:\\" & strComputer & "\" & strNamespace & ":Win32_Process")
    intError = objProcess.Create(strSource, null, objConfig, intProcessID)
  Else

    ' strDomain = "WORKGROUP" 
    'strUser = Login 
    'strPassword = Password

    'Set objSWbemLocator = CreateObject("WbemScripting.SWbemLocator") 
    'Set objWMIService = objSWbemLocator.ConnectServer(strComputer, _ 
    '"root\CIMV2", _ 
    'strUser, _ 
    'strPassword, _ 
    '"MS_409", _ 
    '"ntlmdomain:" + strDomain) 

    ' Obtain the definition of the class.
    Dim objShare
    Set objShare = objWMIService.Get("Win32_ScheduledJob")

    ' Obtain an InParameters object specific
    ' to the method.
    Dim objInParam
    Set objInParam = objShare.Methods_("Create").inParameters.SpawnInstance_()

    ' Add the input parameters.
    objInParam.Properties_.Item("Command") =  strSource
    objInParam.Properties_.Item("StartTime") =  "********" & Replace(Left(Right(DateAdd("n", 1, Now()), 8), 5), ":", "") & "00.000000+180"
    objInParam.Properties_.Item("RunRepeatedly") =  False
    objInParam.Properties_.Item("DaysOfWeek") =  0
    objInParam.Properties_.Item("DaysOfMonth") =  0
    objInParam.Properties_.Item("InteractWithDesktop") =  True

    ' Execute the method and obtain the return status.
    ' The OutParameters object in objOutParams
    ' is created by the provider.
    Dim objOutParams
    Set objOutParams = objWMIService.ExecMethod("Win32_ScheduledJob", "Create", objInParam)

    ' List OutParams
    intError = objOutParams.ReturnValue
    intProcessID = objOutParams.JobId
  End If

  '    
  If intError <> 0 Then
    '    
    call LogMsg(EventError, "Can't create process: " & ProcessName & " on " & ComputerName)
  Else
    '     
    call LogMsg(EventInfo, "Process: " & ProcessName & " ID:" & intProcessID & " created on " & ComputerName)
  End If
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:       '
'             Log Server'             '
'                                                        '
' Inputs:                     '
'                                                        '
' Returns:                                         '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub LogMsg(intType, strMsg)
   Dim WshShell
   Set WshShell = WScript.CreateObject("WScript.Shell")
   WshShell.LogEvent intType, strMsg
   Dim oExec
   Set oExec = WshShell.Exec(WshShell.CurrentDirectory & "\sender.exe " & intType & " """ & strMsg & """")
   Do While oExec.Status = 0
      WScript.Sleep 100
   Loop
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:                    '
'                                        '
'                                                        '
' Inputs:                                '
'                                                        '
' Returns: Boolean                                       '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function FileStatus(strFile)
' On error resume next
' Dim objFile
' Set objFile = GetObject("winmgmts:CIM_DataFile.Name='" & Replace(strFile, "\", "\\") & "'")
' If objFile.Status = "OK" Then
'   FileStatus = TRUE
' Else
'   FileStatus = FALSE
' End If
 On error resume next
 FileStatus = FALSE
 Dim objWMI
 If strComputer = "." Then
   Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer &  "\" & strNamespace)
 Else
   Set objLocator = CreateObject("WbemScripting.SWbemLocator")
   Set objWMI = objLocator.ConnectServer(strComputer, strNamespace, Login, Password)
 End If

 Dim collObj
 Set collObj = objWMI.ExecQuery("SELECT * FROM Win32_LogicalFileSecuritySetting WHERE Path='" & Replace(strFile, "\", "\\") & "'")
 Dim objItem
 For Each objItem in collObj
   FileStatus = TRUE
   Exit For
 Next
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:                 '
'                                                        '
' Inputs:                                     '
'                                                        '
' Returns: Boolean                                       '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function StatusProcess(strProcess)
 On error resume next
 StatusProcess = FALSE
 Dim oService
 If strComputer = "." Then
   Set oService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer &  "\" & strNamespace)
 Else
   Set objLocator = CreateObject("WbemScripting.SWbemLocator")
   Set oService = objLocator.ConnectServer(strComputer, strNamespace, Login, Password)
 End If

 Dim cProcesses
 Set cProcesses = oService.ExecQuery("Select * from Win32_Process Where Name='" & strProcess & "'")
 Dim oProcess
 For Each oProcess in cProcesses
    If oProcess.ProcessId <> 0 Then
       StatusProcess = TRUE
       Exit Function
    End If
 Next
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:          '
'                                                        '
' Inputs:   0  31                               '
'                                                        '
' Returns:                 '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function fPriority(intPriority)
'  
 Const NORMAL       = 32
 Const IDLE         = 64
 Const HIGH         = 128
 Const REALTIME     = 256
 Const BELOW_NORMAL = 16384
 Const ABOVE_NORMAL = 32768

If 4 < intPriority and intPriority <= 7 Then
 fPriority = IDLE
ElseIf  7 < intPriority and intPriority <= 13 Then
 fPriority = NORMAL 
ElseIf  13 < intPriority and intPriority <= 23 Then
 fPriority = HIGH 
ElseIf  23 < intPriority and intPriority <= 31 Then
 fPriority = REALTIME
Else
 fPriority = NORMAL 
End If
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:    ,             '
'                                    '
'                                                        '
' Inputs:                     '
'                                                        '
' Returns:                     '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function fWindow(strWindow)
 Select Case UCase(strWindow)
 Case "HIDE"            fWindow = SW_HIDE
 Case "NORMAL"          fWindow = SW_NORMAL
 Case "SHOWMINIMIZED"   fWindow = SW_SHOWMINIMIZED
 Case "SHOWMAXIMIZED"   fWindow = SW_SHOWMAXIMIZED
 Case "SHOWNOACTIVATE"  fWindow = SW_SHOWNOACTIVATE
 Case "SHOW"            fWindow = SW_SHOW
 Case "MINIMIZE"        fWindow = SW_MINIMIZE
 Case "SHOWMINNOACTIVE" fWindow = SW_SHOWMINNOACTIVE
 Case "SHOWNA"          fWindow = SW_SHOWNA
 Case "RESTORE"         fWindow = SW_RESTORE
 Case "SHOWDEFAULT"     fWindow = SW_SHOWDEFAULT
 Case "FORCEMINIMIZE"   fWindow = SW_FORCEMINIMIZE
 Case Else              fWindow = SW_NORMAL
 End Select
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Purpose:        '
'                                                  '
'                                                        '
' Inputs:                                          '
'                                                        '
' Returns:                                  '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function NameOfComp()
 Dim oWMIService
 If strComputer = "." Then
   Set oWMIService = GetObject("winmgmts:\\" & strComputer &  "\" & strNamespace) 
 Else
   Set objLocator = CreateObject("WbemScripting.SWbemLocator")
   Set oWMIService = objLocator.ConnectServer(strComputer, strNamespace, Login, Password)
 End If

 Dim colItems
 Set colItems = oWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem",,48) 
 Dim objItem
 For Each objItem in colItems
   If Not IsEmpty(objItem.Name) Then
     NameOfComp = objItem.Name
     Exit Function  
   End If
 Next
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Last data modification: 06.08.2006                     '
'                                                        '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''